<template>
  <v-card>
    <v-row>
      <v-col cols="12" md="8">
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Buscar"
          single-line
          hide-details
          class="mx-2"
        ></v-text-field>
      </v-col>
      <v-col cols="12" md="4" class="text-center">
        <v-btn v-if="loggedIn==true && lastPurchase>6" dark x-large color="#414142" @click="dialog = !dialog, calculateTotal()">Lista de compras</v-btn>
      </v-col>
      <v-col v-for="n in packages" :key="n.id" cols="12" lg="3" md="4" sm="6">
        <v-card raised>
          <v-img :src="n.photo" height="200px"></v-img>
          <v-card-text>
            <h2>{{n.title}}</h2>
            Precio: {{n.price}}
              <v-tooltip top>
                <template v-slot:activator="{ on }">
                  <v-btn small rounded outlined color="#414142" dark class="mx-2" v-on="on">
                    <v-icon class="mr-2">mdi-eye</v-icon>
                    Ver productos
                  </v-btn>
                </template>
                <div v-for="m in n.products" :key="m.name">{{m.name}}</div>
              </v-tooltip>
          </v-card-text>
          <v-card-actions v-if="loggedIn==true && lastPurchase>6">
            <v-btn depressed :disabled="toast"
            :loading="toast" @click="sendPackages(n), toast=true">
              <v-icon large>mdi-check</v-icon>
               Comprar paquete
            </v-btn>
            
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-dialog v-model="dialog" max-width="500px">
        <v-card>
          <v-card-title>
            <span class="headline">Lista de Compras</span>
          </v-card-title>
          <v-card-text>
            <v-simple-table dense>
              <template v-slot:default>
                <thead>
                  <tr>
                    <th class="text-left">Nombre</th>
                    <th class="text-left">Precio</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in packagesList" :key="item.id">
                    <td>{{ item.name }}</td>
                    <td>{{ item.price }}</td>
                    <td class="text-center">
                      <v-btn icon fab dark color="#414142" @click="deletePackages(item.id), calculateTotal()">
                        <v-icon dark>mdi-delete</v-icon>
                      </v-btn>
                    </td>
                  </tr>
                  <tr>
                    <td>Precio Total:</td>
                    <td>{{priceList}}</td>
                    <td></td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn dark color="red" @click="dialog = false">Cancelar</v-btn>
            <v-btn v-if="packagesList.length!=0" dark color="#8CC63F" @click="dialog = false, makePurchase()">Realizar compra</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-snackbar
        v-model="toast"
        :timeout="timeout"
      >
        {{ toast_msg }}
        <v-btn
          color="blue"
          text
          @click="toast = false"
        >
          Close
        </v-btn>
      </v-snackbar>
  </v-card>
</template>

<script>
import "firebase/auth";
import * as firebase from "firebase/app";
export default {
  props: {
    loggedIn: {
      type: Boolean
    },
    lastPurchase: {
      
    }
  },
  data() {
    return {
      timeout: 2000,
      sale:[],
      toast: false,
      toast_msg: "",
      dialog: false,
      search: null,
      packagesList: [],
      priceList: 0,
      packages: []
    };
  },
  mounted() {
    this.show_prods();
  },
  methods: {
    sendPackages(a) {
      if(this.packagesList.length<2){
        this.packagesList.push({id: a.id, name: a.title, price: a.price});
        this.toast_msg="Se agregó un paquete de "+a.title
      }else{
        this.toast_msg="Máximo se pueden seleccionar 2 paquetes"
      }
    },
    deletePackages(id){
      this.packagesList.forEach(pack => {
            if(pack.id==id){
              this.packagesList.splice(this.packagesList.indexOf(pack), 1)
            }
        })
    },
    show_prods() {
      this.$axios
        .get(`http://${process.env.VUE_APP_API_URL}/api/packages`)
        .then(res => {
          res.data.data.forEach(pack => {
            let aux = [];
            pack.info.products.forEach(product => {
              aux.push({ name: product.name });
            });
            this.packages.push({
              id: pack.id,
              title: pack.info.name,
              price: pack.info.cost,
              photo: pack.photoUrl,
              products: aux
            });
          });
        });
    },
    calculateTotal(){
      let total=0
      this.packagesList.forEach(pack => {
        total+=pack.price
      })
      this.priceList=total
    },
    async makePurchase(){
      const token = await firebase.auth().currentUser.getIdToken();
      let config = {
            headers:{
              authorization: `Bearer ${token}`
            },
            body:{
              
            }
          }
      this.sale.push({cost:this.priceList, products:[], packages:this.packagesList})
      this.$axios
        .post(`http://${process.env.VUE_APP_API_URL}/api/sales`,{sales:this.sale}, config)
        .then(res =>{
          if(res.data.message=="successful sale"){
            this.packagesList=[]
            this.toast_msg="Pedido realizado correctamente"
            this.toast=true
            this.$emit('toOrder', 2)
          }
        })
        .catch(function(err){
          console.log(err)
        })
    },
  }
};
</script>
